// NetBlaster Lite (C) written by Steve Cox 6/3/94
// Has no Comm routines for modem to modem Playing
//

#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <math.h>
#include <string.h>
#include <mem.h>
#include <bios.h>
#include <ctype.h>
#include <conio.h>


extern "C" {
#include "rend386.h"
#include "userint.h"
#include "plg.h"
#include "splits.h"
#include "tasks.h"
#include "pointer.h"
#include "cursor.h"
#include "segasupp.h"
#include "segio.h"
#include "intmath.h"
#include "morerend.h"

void screen_refresh(VIEW *);
void printxyr(int,int,int,char *,int);
int  read_world(FILE *);
void preset_default_colors(void);

}

void exit_program(void);
void handle_key(void);


#define to_rad(a) ((a) * 3.14159262 / 180.0)
#define sine(x)   sin(to_rad(x/65536L))
#define cosine(x) cos(to_rad(x/65536L))

long  pan_speed=400000L;    // the speed at witch you pan your viewpoint
long  tilt_speed=200000L;   // the speed at witch you tilt your viewpoint
long  backward_speed=350L;  // the speed at witch you tilt your viewpoint
long  forward_speed=0L;     // the speed at witch you tilt your viewpoint
long  heading=0L;    // The direction the VIEW is heading
int   offset=750;
int   CURRENT_OBJ;


//--------------------------------------------------------------------------
class GFXOBJECT
{
	public:
	  SEGMENT *OBJ;
	  int	 xpos,ypos,zpos,obj_scale;
	  long   obj_heading,obj_speed;
	  GFXOBJECT();
	  ~GFXOBJECT();
	  virtual void  init(int x,int y,int z,long h,long speed,int scale);
	  virtual int   load(char *);
	  virtual void  move();              //Move GFXOBJECT with internal
					     //values as they are
	  virtual void  move(int,int,int);   //Move GFXOBJECT with NEW values
	  virtual void  rotate(int,int,int); // rotate

};
//-------------------------------------------------------------------------
GFXOBJECT::GFXOBJECT()
{
       //set private data
	  xpos=ypos=zpos=0;
	  obj_heading=obj_speed=0;
	  return;
}
//-------------------------------------------------------------------------
GFXOBJECT::~GFXOBJECT()
{
      return;
}
//------------------------------------------------------------------------
void GFXOBJECT::init(int x,int y,int z,long h,long s,int scale)
{
     xpos=x;
     ypos=y;
     zpos=z;
     obj_heading=h;
     obj_speed=s;
     obj_scale=scale;
     return;
}
//------------------------------------------------------------------------
void GFXOBJECT::move()
{
    abs_move_segment(OBJ,xpos+=obj_speed*cosine(obj_heading),
			 ypos,
			 zpos-=obj_speed * sine(obj_heading));
    update_segment(OBJ);

     return;
}
//------------------------------------------------------------------------
void GFXOBJECT::move(int x,int y,int z)
{
     xpos=x;
     ypos=y;
     zpos=z;
     abs_move_segment(OBJ,xpos+=obj_speed*cosine(obj_heading),ypos,
		      zpos-=obj_speed * sine(obj_heading));
     update_segment(OBJ);

    return;
}
//------------------------------------------------------------------------
void GFXOBJECT::rotate(int x,int y,int z)
{
  rel_rot_segment(OBJ,x*65536L,y*65536L,z*65536L,RYXZ);
  update_segment(OBJ);

}
//------------------------------------------------------------------------
int GFXOBJECT::load(char *filename)
{
   FILE *in;
   OBJECT *obj;
   SEGMENT *obj_seg;

  if((in = fopen(filename,"r" )) == NULL)
    {
      fprintf(stderr,"Unable to open file.\n" );
      delay(2000);
      return 0;
    }

  set_loadplg_offset( 0, 0, 0 );
  set_loadplg_scale(obj_scale,obj_scale,obj_scale);
  obj = load_plg(in);
  if(load_err != 0)
    {
      fprintf(stderr, "Error loading *.plg file.\n" );
      delay(2000);
      return 0;

    }
    add_to_objlist(objlist,obj);
    obj_seg=new_seg(NULL);
    seg_set_object(obj_seg,obj);
    update_segment(obj_seg);
    OBJ=obj_seg;
    return 1;
}
//--------------------------------------------------------------------------
class Projectile : public GFXOBJECT
{
	public:

	 Projectile() : GFXOBJECT(){}
     //	~Projectile() ;
	 int   firex,firey,firez,trigger,nonstop;
	 float time;
	 virtual void move();     //move Obj
	 virtual void init(int,int,int,long,long,int);
		 void fire(void);


};
//------------------------------------------------------------------------
void Projectile::init(int x,int y,int z,long h,long s,int scale)
{
     firex=0;
     firey=0;
     firez=0;
     obj_heading=h;
     obj_speed=s;
     obj_scale=scale;
     xpos=x;
     ypos=y;
     zpos=z;
     time=0;
     nonstop=0;
     trigger=0;
     return;

};
//------------------------------------------------------------------------
void Projectile::move()
{

  // trajectory calculation

  if(trigger == 0) return;
     firex=xpos+cosine(obj_heading)*obj_speed*(time+=.1);  //calc for x incrementation
     firez=zpos+sine(obj_heading)*obj_speed*time;          //calc for z incrementation
     firey=ypos+(-1)*(time*time);                          //calc rate of fall

      if(firey < 0)
       {
	 time=0;                  // Projectile hit the ground
	 if(!nonstop) trigger=0;  // so turn off its movement
       }

    abs_move_segment(OBJ,firex,firey,firez);
    update_segment(OBJ);
    return;

};
//------------------------------------------------------------------------
void Projectile::fire()
{
    if(trigger == 1) return;
    else
	trigger=1;
    return;
};
//------------------------------------------------------------------------

       Projectile  M1,M2,M3;

//--------------------------------------------------------------------------
class GunShip1 : public GFXOBJECT
{
	public:

	 GunShip1():GFXOBJECT(){}
	 virtual void fire(void);
	 virtual void move(void);

};
//------------------------------------------------------------------------
void GunShip1::move(void)
{

    GFXOBJECT::move();
    if(M2.trigger) M2.move();
    return;
};
//------------------------------------------------------------------------
void GunShip1::fire(void)
{
    M2.init(xpos-10,ypos+100,zpos-10,-obj_heading,1500,1);
    M2.fire();
    return;
};
//--------------------------------------------------------------------------
class Ball : public GFXOBJECT
{
   public:

   Ball() : GFXOBJECT(){}
   int      inc_x,inc_y,inc_z;
   int      ceiling,floor,right_wall,left_wall,front_wall,back_wall;
   virtual  void move();           //move object
   virtual  void init_boundry(int c,int f,int rw,int lw,int fw,int bw);

};
//------------------------------------------------------------------------
void Ball::init_boundry(int c,int f,int lw,int rw,int bw,int fw)
{

     ceiling=c;
     floor=f;
     right_wall=rw;
     left_wall=lw;
     front_wall=fw;
     back_wall=bw;
     inc_x=50;
     inc_y=40;
     inc_z=40;
     return;

}
//------------------------------------------------------------------------
void Ball::move()
{

    ypos+=inc_y;

  if(ypos > ceiling)
    {
      inc_y = -obj_speed;
      ypos+=inc_y;
    }
  else
    if(ypos <= floor)
     {
       inc_y = obj_speed;
       ypos+=inc_y;
     }

    xpos+=inc_x;

   if( xpos > right_wall)
    {
      inc_x = -obj_speed;
      xpos+=inc_x;
    }
  else
   if(xpos < left_wall)
    {
      inc_x = obj_speed;
      xpos+=inc_x;
     }

  if(inc_z > obj_speed)  inc_z -=1;
  if(inc_z < -obj_speed) inc_z +=1;

  zpos+=inc_z;
  if(zpos > front_wall)
    {
      inc_z = -obj_speed;
       zpos+=inc_z;
    }
  else
   if( zpos <= back_wall)
    {
       inc_z = obj_speed;
       zpos+=inc_z;
     }

    abs_move_segment(OBJ,xpos,ypos,zpos);
    update_segment(OBJ);

     return;
}
//-------------------- Object Stuff ----------------------------------

    Ball       B1;
    GunShip1   G1;

//----------------------------------------------------------------------
void main(int argc, char *argv[])
{

  int i=0;
  char *fname, *in_filename;
  FILE *in;
  int x=0,y=0,z=0,rad;
  long dist;

   clrscr();
   printf(" \n\n\n\n");
   printf("            NetBlaster(C) -Lite-  Written by Steve Cox using\n");
   printf("                        Rend386 ver. 4.0\n");
   printf(" \n\n\n\n");
   printf("            Stop by the Houston Game Designer BBS !!!!!!!!\n");
   printf("                    (713) 955-8920   -   14.4K\n");
   printf("                       Hit any key\n");
   getch();

  setup_render(40,800);
  atexit(closeall);
  set_global_split_root(&split_tree);
  initial_world_split(&split_tree);
  objlist=new_objlist();

  fname = "rend386.cfg";
  if((in = fopen( fname, "r" )) == NULL)
    {
      fprintf ( stderr, "Configuration file not found!" );
      exit(1);
    }
  else
    {
      if(read_world(in))
	{
	   fprintf( stderr, "Error reading configuration file!" );
	   exit(1);
	}
      fclose(in);
    }

  in_filename = fix_fname(argv[1] );
  if(strstr(in_filename, ".wld"))
    {
      if((in = fopen( in_filename, "r" )) == NULL )
	{
	  fprintf(stderr, "Error opening world file.\n" );
	  exit(1);
	}
      if(read_world(in))
	{
	  fprintf( stderr, "Error reading world file.\n");
	  exit(1);
	}
      fclose(in);
    }

  load_video_driver( vdname );
  screeninfo = screen_data();
  highest_color = screeninfo->colors-1;
  preset_default_colors();

  frame_x = screeninfo->xmin;
  frame_y = screeninfo->ymin;
  frame_w = screeninfo->xmax - screeninfo->xmin+1;
  frame_h = screeninfo->ymax - screeninfo->ymin+1;

  default_view.left = screeninfo->xmin;
  default_view.top = screeninfo->ymin;
  default_view.right = screeninfo->xmax;
  default_view.bottom = screeninfo->ymax;
  default_view.aspect = screeninfo->aspect;


  if(enter_graphics())
   {
     fprintf( stderr,"could not enter graphics mode\n\n");
     exit(1);
    }

  screen_clear_color = 0;
  initialize_screen_factors(current_view);
  fast_view_factors(current_view);

  G1.init(1000,0,2000,90*65536L,0,1);
  G1.load("methead.plg");
  G1.move();
  G1.rotate(0,180,0);

  //Projectile
  M1.init(-5000,1000,5000,-35*65536L,550,1);
  M1.load("f1171.plg");
  M1.nonstop=1;           // restart bullet if it hits the ground
  M1.rotate(0,135,0);
  M1.fire();


  // Bullet Object
  M2.init(0,50,0,0L,1000,1);
  M2.load("ball.plg");
  M2.move();


  B1.init(1000,500,2000,0L,50,4);
  B1.init_boundry(850,0,-850,850,0,850);
  B1.load("ball.plg");
  B1.move();

  // Turn so your Avatar Methead is facing you

  for(i=0;i < 15;i++)  heading -= pan_speed;

 while(execution)
  {
     handle_key();
     G1.move();
     B1.move();
     M1.move();
     current_view->ex=G1.xpos+offset * cosine(heading);
     current_view->ez=G1.zpos+offset * sine(heading);
     refresh_display();

   }
   exit(0);

}
//-------------------------------------------------------------------------
void handle_key(void)
{

     unsigned  int  c,num=0,i=0,obj_index=0;


if(bioskey(1))
 {
   c=getkey();    // Key hit so switch on it

  switch( c )
    {
     case 'q':
     case 'Q': popmsg( "Do you wish to quit? (y/n)" );
	       if(toupper(getkey())== 'Y')
		 {
		   execution = 0;

		  }
	       else redraw = 1;
	       break;

     case 'f':
     case 'F':
	       break;
     case 'd':
     case 'D':
	       break;


     case 'b':
     case 'B':
	       offset -= 5;if(offset <=  500); offset = 500;
	       break;

     case 'n':
     case 'N':
	       offset -= 5;if(offset <=  500); offset = 500;
	       break;

     case 'v':
     case 'V':
		G1.fire();
		break;


     case 'h':
     case 'H':
	       break;


     case  'm':
     case  'M':
		 break;

     case 'a':
     case 'A':
		 break;

    /* Home Key  Step by 1 angle value */
    case 0x4700: current_view->tilt += tilt_speed;
		 break;

    /* End Key   Step by 1 angle value */
    case 0x4F00: current_view->tilt -= tilt_speed;
		 break;

    /* Arrow Left  Step by 1 angle value */
    case 0x4B00:
		 G1.rotate(0,-30,0);
		 G1.obj_heading-=30*65536L;
		 break;

    /* Arrow Right.  Step by 1 angle value */
    case 0x4D00:
		 G1.rotate(0,30,0);
		 G1.obj_heading+=30*65536L;
		 break;

    // Move Backwards
    case 0x5000:
		 G1.obj_speed-=10L;
		 if(G1.obj_speed < 0) G1.obj_speed=0;
		 break;

    // Move Forwards
    case 0x4800:
		 G1.obj_speed+=10L;
		 if(G1.obj_speed > 200) G1.obj_speed=200;
		 break;


    //F1         PAN Viewpoint
    case 0x3C00: current_view->pan -= pan_speed;
		 heading += pan_speed;
		 break;

    //F2         Pan Viewpoint
    case 0x3B00: current_view->pan += pan_speed;
		 heading -= pan_speed;
		 break;

    //F3
    case 0x3D00: heading -= pan_speed;
		 break;

     //F4
    case 0x3E00: heading += pan_speed;
		 break;

     }

   }

}
//------------------------------------------------------------------------
void prprint(int x,int y, int color, char *t)
{
	int bk = (color>8) ? 0 : 15;

	printxyr(x,y,bk,t,0);
	printxyr(x+1,y+1,color,t,0);
}
//-------------------------------------------------------------------------
void load_video_driver ( char *dfile )
{
  v_driver_pointer = load_driver ( dfile );
  if ( v_driver_pointer == NULL )
  {
	fprintf ( stderr, "Bad video driver/n" );
	exit ( 1 );
  }
}

/**************************************************************************
   This function is used by the file render.c to display various things
   on the screen to the user.  This is not needed by any program just
   an option.  However, render.c needs access to this function
***************************************************************************/
void status_on_screen()
{
}
/**************************************************************************
   This function concatenates the loadpath to the string name IF
   name is not "\\" and not "/" and loadpath is not empty.  It is used by
   the files: world.c.
**************************************************************************/
char *fix_fname(char *name)
{

	if (loadpath[0] && !strchr(name, '\\') && !strchr(name, '/'))
		sprintf(tempname, "%s\\%s", loadpath, name);
	else
		strcpy(tempname, name);
	return tempname;
}
/**************************************************************************
  This function is called when the user ends the graphics program.  It
  shuts done the graphics system and exits the renders and finally exits
  the progam.
**************************************************************************/
void closeall()
{
  exit_graphics();
  reset_render();
  //if(commstat==1)  Close_Port();
  exit(0);
}
/**************************************************************************
   This function is from Rend386 demo2.c program and is used to get
   keyboard input from the user.
***************************************************************************/
unsigned getkey()
{

  unsigned c;
  union REGS regs;

  regs.h.ah = 2;
  int86(0x16, &regs,&regs );
  shifted = (regs.h.al & 3);
  if ((c=bioskey(0)) & 0xff) c &= 0xff;
  else if ( shifted ) c |= 1;
  return c;
}
//------------------------------------------------------------------------
void refresh_display()
{
  initialize_screen_factors( current_view );
  fast_view_factors( current_view );
  screen_refresh( current_view );

}
